function drawCircle(x, y, radius, startAngle, endAngle)
{
   segm = (endAngle - startAngle) / 5;
   this.moveTo(x + radius * Math.cos(startAngle * Math.rad),y + radius * Math.sin(startAngle * Math.rad));
   var s = startAngle + segm;
   while(s <= endAngle + 1)
   {
      var c_x = radius * Math.cos(s * Math.rad);
      var c_y = radius * Math.sin(s * Math.rad);
      var a_x = c_x + radius * Math.tan(segm / 2 * Math.rad) * Math.cos((s - 90) * Math.rad);
      var a_y = c_y + radius * Math.tan(segm / 2 * Math.rad) * Math.sin((s - 90) * Math.rad);
      this.curveTo(a_x + x,a_y + y,c_x + x,c_y + y);
      s += segm;
   }
}
function redraw(starty)
{
   dx = (dx + (newX - mx) * 1 / az) / bz;
   dy = (dy + (newY - my) * 1 / az) / bz;
   mx += dx;
   my += dy;
   dr = (dr + (newDepth - depth) * 1 / az) / bz;
   depth += dr;
   _root.clear();
   if(depth > 1)
   {
      i = 1;
      while(i < max)
      {
         _root.lineStyle(8,0,100);
         ly = starty + i * ystep;
         cRadius = Math.abs(my - ly) + depth;
         px1 = mx - Math.sqrt(cRadius * cRadius - (my - ly) * (my - ly));
         px2 = mx + Math.sqrt(cRadius * cRadius - (my - ly) * (my - ly));
         _root.moveTo(0,ly);
         _root.lineTo(px1,ly);
         _root.moveTo(px2,ly);
         _root.lineTo(750,ly);
         sAngle = Math.atan2(ly - my,px1 - mx) / Math.rad;
         eAngle = Math.atan2(ly - my,px2 - mx) / Math.rad;
         if(sAngle > eAngle)
         {
            var tmp = sAngle;
            sAngle = eAngle;
            eAngle = tmp;
         }
         _root.drawCircle(mx,my,cRadius,sAngle,eAngle);
         i++;
      }
   }
   else
   {
      i = 1;
      while(i < max)
      {
         _root.lineStyle(8,0,100);
         ly = starty + i * ystep;
         _root.moveTo(0,ly);
         _root.lineTo(750,ly);
         i++;
      }
   }
   if(mDown)
   {
      if(depth < 30)
      {
         depth += 1;
      }
   }
   else if(depth > 0)
   {
      depth -= 1;
   }
}
_root.onMouseDown = function()
{
   mDown = true;
   newDepth = 50;
};
_root.onMouseUp = function()
{
   newDepth = 0;
   mDown = false;
};
_root.onMouseMove = function()
{
   newX = _root._xmouse;
   newY = _root._ymouse;
};
width = 200;
depth = 0;
newDepth = 0;
dr = 0;
ystep = 10;
max = width / ystep;
mDown = false;
az = 3;
bz = 1.36;
Math.rad = 0.017453292519943295;
setInterval(redraw,1,(400 - width) / 2);
